<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );


/**
 * RubberDoc Controller
 *
 * @package		Joomla
 * @subpackage	RubberDoc
 * @since 1.5
 */
 
 class RubberDocControllerDoc extends RubberDocController
{
	
	private $dirname;
	
	public function __construct($config = array())
	{
		parent::__construct($config);

		// Register Extra tasks
		$this->registerTask( 'add',  'display' );
		$this->registerTask( 'edit', 'display' );
		$this->registerTask( 'apply', 'save' );
		
		$config  =& JComponentHelper::getParams( 'com_rubberdoc');
		$this->dirname = $config->get('rubberdoc_dir', 'rubberdoc');
	}
	
	public function display( )
	{
		global $mainframe, $option;
		
		switch($this->getTask())
		{
			case 'add'     :
			{
				if( !JFolder::exists( JPATH_SITE.DS.$this->dirname ) )
 					$mainframe->redirect('index.php', JText::_('Please create a writable directory in the Joomla root and name it "'.$this->dirname.'"'), 'error');
				
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'edit', false );

				// Checkout the document
				$model = $this->getModel('doc');
				$model->checkout();
			} break;
			
			case 'edit'    :
			{
				if( !JFolder::exists( JPATH_SITE.DS.$this->dirname ) )
 					$mainframe->redirect('index.php', JText::_('Please create a writable directory in the Joomla root and name it "'.$this->dirname.'"'), 'error');
				
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'edit', true );

				// Checkout the document
				$model = $this->getModel('doc');
				$model->checkout();
			} break;
			
			default: JRequest::setVar('view', 'docs');
		}

		parent::display();
	}
	
	public function save()
	{
		global $mainframe, $option;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];

		$model = $this->getModel('doc');

		if ($model->store($post)) {
			$msg = JText::_( 'Document Saved' );
		} else {
			$msg = JText::_( 'Error Saving Document' );
		}
		
		if( JRequest::getCmd('task') == 'apply' )
		{
			$link = 'index.php?option='.$option.'&view=doc&task=edit&cid[]='.$model->getId();
		} else {
			$model->checkin();
			$link = 'index.php?option='.$option.'&view=docs';
		}

		$this->setRedirect($link, $msg);
	}
	
	public function remove()
	{
		global $option;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('doc');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option='.$option.'&view=docs' );
	}
	
	public function publish()
	{
		global $option;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('doc');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option='.$option.'&view=docs' );
	}
	
	public function unpublish()
	{
		global $option;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('doc');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option='.$option.'&view=docs' );
	}
	
	public function cancel()
	{
		global $option;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Checkin the document
		$model = $this->getModel('doc');
		$model->checkin();

		$this->setRedirect( 'index.php?option='.$option.'&view=docs' );
	}
	
	
	/**
	* changes the access level of a record
	* @param integer The increment to reorder by
	*/
	function changeAccess()
	{
		global $mainframe, $option;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$model = $this->getModel('doc');
		
		$access = JRequest::getInt('access');
		
		jexit();
		
		$model->changeAccess();

		$this->setRedirect( 'index.php?option='.$option.'&view=docs' );
	}
	
// end class	
}
