<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );
jimport('joomla.error.log');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * RubberDoc Controller
 *
 * @package		Joomla
 * @subpackage	RubberDoc
 * @since 1.5
 */
 
 class RubberDocControllerUpload extends RubberDocController{
 
 	public function display()
 	{
 		global $mainframe, $option;
 		
 		$config  =& JComponentHelper::getParams( 'com_rubberdoc');
 		$dirname = $config->get('rubberdoc_dir', 'rubberdoc');
 		
 		if( !JFolder::exists( JPATH_SITE.DS.$dirname ) )
 			$mainframe->redirect('index.php', JText::_('Please create a writable directory in the Joomla root and name it "'.$dirname.'"'), 'error');
 		
 		JRequest::setVar('view', 'upload');
 		parent::display();
 	}
 	
 	public function upload()
 	{
 		global $mainframe, $option;
 		
 		// Check for request forgeries
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );
		
		$file 			= JRequest::getVar( 'Filedata', '', 'files', 'array' );
		$file['name']	= JFile::makeSafe($file['name']);
		
		$model =& $this->getModel('doc');
		
		$post = array();
		$post['id'] 			= null;
		$post['category_id']	= JRequest::getInt('category_id', 0);
		$post['published']		= JRequest::getInt('published', 0);
		
		//make title
		$title = $file['name'];
		$title = explode('.', $title);
		$temp = array_pop($title);
		$post['title'] = implode('_', $title);
		
		if ($model->store($post)) {
			$msg = JText::_( 'Document Saved' );
		} else {
			$msg = JText::_( 'Error Saving Document' );
		}
		
		jexit($msg);
 	}
 	
 	private function logMessage( $msg='' )
 	{
 		$log = &JLog::getInstance('rubberdoc.error.php');
		$log->addEntry(array('comment' => (string) $msg ."\n" ));
 	}
 	
 // end class
 }