<?php
/**
 * @version     $Id:rubberdoc.install.php 51 2007-10-18 12:35:24Z rmdstudio $
 * @package     RubberDoc
 * @copyright   Copyright (C) 2007 - 2008 Joomlatools. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPLv2
 * @author      Rastin Mehr <rastin@rmdstudio.com>
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.folder');

$status = new JObject();

// Get the database connection object and make sure we are using the unwrapped version
$db = &$this->parent->getDBO();
if (isset($db->dbo) && is_object($db->dbo)) {
    $mydb = &$db->dbo;
    $db = $mydb;
}



/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * rubberdoc Content Plugin
 * ---------------------------------------------------------------------------------------------
 * **********************************************************************************************/

// Set the plugin root path
$this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.'content');

// Delete the module in the #__plugins table
$query = 'DELETE FROM #__plugins WHERE element = '.$db->Quote('rubberdoc').' AND folder = '.$db->Quote('content');
$db->setQuery($query);
if (!$db->query()) {
    JError::raiseWarning(100, JText::_('Plugin').' '.JText::_('Uninstall').': '.$db->stderr(true));
    $retval = false;
}

// Set the installation path
$element =& $this->manifest->getElementByPath('rubberdoccontent/files');
if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
    $this->parent->removeFiles($element, -1);
}

// If the folder is empty, let's delete it
$files = JFolder::files($this->parent->getPath('extension_root'));
if (!count($files)) {
    JFolder::delete($this->parent->getPath('extension_root'));
}


// remove all the document files
$path = JPATH_SITE.DS.'documents';

if( JFolder::exists( $path ) )
	JFolder::delete( $path );

$status->set('rubberdoccontent', true);






/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * rubberdoc Search Plugin
 * ---------------------------------------------------------------------------------------------
 * **********************************************************************************************/

// Set the plugin root path
$this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.'search');

// Delete the module in the #__plugins table
$query = 'DELETE FROM #__plugins WHERE element = '.$db->Quote('rubberdoc').' AND folder = '.$db->Quote('search');
$db->setQuery($query);
if (!$db->query()) {
    JError::raiseWarning(100, JText::_('Plugin').' '.JText::_('Uninstall').': '.$db->stderr(true));
    $retval = false;
}

// Set the installation path
$element =& $this->manifest->getElementByPath('rubberdocsearch/files');
if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
    $this->parent->removeFiles($element, -1);
}

// If the folder is empty, let's delete it
$files = JFolder::files($this->parent->getPath('extension_root'));
if (!count($files)) {
    JFolder::delete($this->parent->getPath('extension_root'));
}


if( JFolder::exists( $path ) )
	JFolder::delete( $path );

$status->set('rubberdocsearch', true);






/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * OUTPUT TO SCREEN
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/
?>

<h1><?php echo JText::_('RubberDoc Uninstallation'); ?></h1>

<table class="adminlist">
    <thead>
        <tr>
            <th class="title"><?php echo JText::_('Task'); ?></th>
            <th width="60%"><?php echo JText::_('Status'); ?></th>
        </tr>
    </thead>
    <tfoot>
        <tr>
            <td colspan="2">&nbsp;</td>
        </tr>
    </tfoot>
    <tbody>
        <tr class="row0">
            <td class="key"><?php echo JText::_('Component'); ?></td>
            <td><strong><?php echo JText::_('Uninstalled'); ?></strong></td>
        </tr>
        
        <tr class="row1">
            <td class="key"><?php echo JText::_('RubberDoc Content Plugin'); ?></td>
            <td><?php echo ($status->get('rubberdoccontent')) ? '<strong>'.JText::_('Uninstalled').'</strong>' : '<em>'.JText::_('NOT Uninstalled').'</em>'; ?></td>
        </tr>
        
        <tr class="row0">
            <td class="key"><?php echo JText::_('RubberDoc Search Plugin'); ?></td>
            <td><?php echo ($status->get('rubberdocsearch')) ? '<strong>'.JText::_('Uninstalled').'</strong>' : '<em>'.JText::_('NOT Uninstalled').'</em>'; ?></td>
        </tr>
    </tbody>
</table>