<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

// Include library dependencies
jimport('joomla.filter.input');

class TableDocs extends JTable
{

	public $id 					= null;
	public $category_id			= null;
	public $file 				= null;
	public $file_size			= null;
	public $title 				= null;
	public $alias 				= null;
	public $description			= null;
	public $downloads			= null;
	public $created				= null;
	public $modified				= null;
	public $published			= null;
	public $checked_out			= null;
	public $checked_out_time	= null;
	public $access				= null;
	public $ordering			= null;
	public $params				= null;
	public $metakey				= null;
	public $metadesc			= null;
	
	
	/**
	*	CONTRUCTOR 
	*/
	function __construct(& $db) {
		parent::__construct('#__rubberdoc_docs', 'id', $db);
	}
	
	
	/**
	* Overloaded bind function
	*
	* @acces	public
	* @param	array $hash named array
	* @return	null|string	null is operation was satisfactory, otherwise returns an error
	* @see		JTable:bind
	* @since	1.5
	*/
	public function bind($array, $ignore = '')
	{
		if (key_exists( 'params', $array ) && is_array( $array['params'] )) {
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}

		return parent::bind($array, $ignore);
	}
	
	
	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @access public
	 * @return boolean True on success
	 * @since 1.0
	 */
	public function check()
	{

		// check for valid title
		if (trim($this->title) == '') {
			$this->_error = JText::_('Your Document must contain a title.');
			return false;
		}
		
		// check for valid alias
		if(empty($this->alias)) {
			$this->alias = $this->title;
		}
		$this->alias = JFilterOutput::stringURLSafe($this->alias);

		if(trim(str_replace('-','',$this->alias)) == '') {
			$datenow =& JFactory::getDate();
			$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
		}

		return true;
	}
	
	function hit( $oid=null, $log=false )
	{
		if (!in_array( 'downloads', array_keys($this->getProperties()) )) {
			return;
		}

		$k = $this->_tbl_key;

		if ($oid !== null) {
			$this->$k = intval( $oid );
		}

		$query = 'UPDATE '. $this->_tbl
		. ' SET downloads = ( downloads + 1 )'
		. ' WHERE '. $this->_tbl_key .'='. $this->_db->Quote($this->$k);
		$this->_db->setQuery( $query );
		$this->_db->query();
		$this->downloads++;
	}
	
// end class
}