<?php
/**
* @version		$Id: view.html.php 10094 2008-03-02 04:35:10Z instance $
* @package		Joomla
* @subpackage	Weblinks
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the RubberDoc component
 *
 * @static
 * @package		Joomla
 * @subpackage	Weblinks
 * @since 1.0
 */
class RubberDocViewDoc extends JView
{
	public function display($tpl = null)
	{
		global $mainframe;

		if($this->getLayout() == 'form') {
			$this->form($tpl);
			return;
		}

		parent::display($tpl);
	}

	private function form($tpl)
	{
		global $mainframe, $option;

		$db		=& JFactory::getDBO();
		$uri 	=& JFactory::getURI();
		$user 	=& JFactory::getUser();
		$model	=& $this->getModel();
		$config  =& JComponentHelper::getParams( 'com_media' );

		$lists = array();

		//get the weblink
		$data	=& $this->get('data');
		$isNew	= ($data->id < 1);

		// fail if checked out not by 'me'
		if ($model->isCheckedOut( $user->get('id') )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The Document' ), $data->title );
			$mainframe->redirect( 'index.php?option='. $option, $msg );
		}

		// Edit or Create?
		if (!$isNew)
		{
			$model->checkout( $user->get('id') );
		}
		else
		{
			// initialise new record
			$data->published = 1;
			$data->category_id = JRequest::getInt( 'category_id', 0);
		}

		// build list of categories
		$lists['category_id'] 		= JHTML::_('list.category',  'category_id', $option, intval( $data->category_id ) );
		// build the html select list
		$lists['published'] 		= JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $data->published );
		
		// build the html select list for the group access
		$lists['access'] 			= JHTML::_('list.accesslevel',  $data );

		//clean weblink data
		JFilterOutput::objectHTMLSafe( $data, ENT_QUOTES, 'description' );

		$xmlFile 	= JPATH_COMPONENT.DS.'models'.DS.'data.xml';
		$params = new JParameter( $data->params, $xmlFile );
		
		//fileType
		if ( $fileName = $data->get('file') )			
			$fileType = array_pop( explode('.', $fileName) );
		else
			$fileType = '';

		$this->assignRef('lists',	$lists);
		$this->assignRef('data',	$data);
		$this->assignRef('params',	$params);
		$this->assignRef('option',	$option);
		$this->assignRef('config',	$config);
		$this->assignRef('fileType',	$fileType);
		
		// Set toolbar items for the page
		$edit = JRequest::getVar('edit',true);
		$text = ( !$edit ) ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'Document' ).': <small><small>[ ' . $text.' ]</small></small>', 'doc.png' );
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if (!$edit)  {
			JToolBarHelper::cancel();
		} else {
		// for existing items the button is renamed `close`
		JToolBarHelper::cancel( 'cancel', 'Close' );
	}

		parent::display($tpl);
	}
}
