<?php
/**
* @version		$Id: view.html.php 10094 2008-03-02 04:35:10Z instance $
* @package		Joomla
* @subpackage	Weblinks
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the RubberDoc component
 *
 * @static
 * @package		Joomla
 * @subpackage	RubberDoc
 * @since 1.0
 */
class RubberDocViewDocs extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option, $params;

		$db		=& JFactory::getDBO();
		$uri	=& JFactory::getURI();
		$config  =& JComponentHelper::getParams( 'com_rubberdoc' );
		$dirname = $config->get('rubberdoc_dir', 'rubberdoc');

		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',		 '',		'word' );
		$filter_category_id	= $mainframe->getUserStateFromRequest( $option.'filter_category_id',	'filter_category_id', 0,			'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		 'a.id',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	 '',		'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			 '',		'string' );
		$search				= JString::strtolower( $search );

		// Get data from the model
		$items		= & $this->get( 'Data');
		$total		= & $this->get( 'Total');
		$pagination = & $this->get( 'Pagination' );

		// build list of categories
		$javascript 	= 'onchange="document.adminForm.submit();"';
		$lists['category_id'] = JHTML::_('list.category',  'filter_category_id', $option, intval( $filter_category_id ), $javascript );

		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;

		// search filter
		$lists['search']= $search;

		$uploadDirectoryExists = JFolder::exists( JPATH_SITE.DS.$dirname );

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);
		$this->assign('option',			$option);
		$this->assign('uploadDirectoryExists', $uploadDirectoryExists);
		$this->assign('dirname', 		$dirname);
		
		JToolBarHelper::title(   JText::_( 'Gestion de documents' ), 'doc.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::preferences('com_rubberdoc', '450');

		parent::display($tpl);
	}



// end class
}