<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'plgSearchDocuments' );
$mainframe->registerEvent( 'onSearchAreas', 'plgSearchDocumentsAreas' );

JPlugin::loadLanguage( 'plg_search_rubberdoc' );

/**
 * @return array An array of search areas
 */
function &plgSearchDocumentsAreas() {
	static $areas = array(
		'rubberdoc' => 'Documents'
	);
	return $areas;
}

/**
* Document Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param string mathcing option, exact|any|all
* @param string ordering option, newest|oldest|popular|alpha|category
 * @param mixed An array if the search it to be restricted to areas, null if search all
 */
function plgSearchDocuments( $text, $phrase='', $ordering='', $areas=null )
{
	$db		=& JFactory::getDBO();
	$user	=& JFactory::getUser();

	require_once(JPATH_SITE.DS.'components'.DS.'com_rubberdoc'.DS.'helpers'.DS.'route.php');

	if (is_array( $areas )) {
		if (!array_intersect( $areas, array_keys( plgSearchDocumentsAreas() ) )) {
			return array();
		}
	}

	// load plugin params info
 	$plugin =& JPluginHelper::getPlugin('search', 'rubberdoc');
 	$pluginParams = new JParameter( $plugin->params );

	$limit = $pluginParams->def( 'search_limit', 50 );

	$text = trim( $text );
	if ($text == '') {
		return array();
	}
	$section 	= JText::_( 'Documents' );

	$wheres 	= array();
	switch ($phrase)
	{
		case 'exact':
			$text		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
			$wheres2 	= array();
			$wheres2[] 	= 'LOWER(a.metadesc) LIKE '.$text;
			$wheres2[] 	= 'LOWER(a.metakey) LIKE '.$text;
			$wheres2[] 	= 'LOWER(a.description) LIKE '.$text;
			$wheres2[] 	= 'LOWER(a.title) LIKE '.$text;
			$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
			break;

		case 'all':
		case 'any':
		default:
			$words 	= explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word)
			{
				$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'LOWER(a.metadesc) LIKE '.$word;
				$wheres2[] 	= 'LOWER(a.metakey) LIKE '.$word;
				$wheres2[] 	= 'LOWER(a.description) LIKE '.$word;
				$wheres2[] 	= 'LOWER(a.title) LIKE '.$word;
				$wheres[] 	= implode( ' OR ', $wheres2 );
			}
			$where 	= '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			break;
	}

	switch ( $ordering )
	{
		case 'oldest':
			$order = 'a.modified ASC';
			break;

		case 'popular':
			$order = 'a.downloads DESC';
			break;

		case 'alpha':
			$order = 'a.title ASC';
			break;

		case 'category':
			$order = '';
			break;

		case 'newest':
		default:
			$order = 'a.modified DESC';
	}
	
	$query = 'SELECT a.id, a.title AS title, a.description AS text, a.created AS created, '
	. ' "'.JText::_('THIS-IS-DOWNLOADABLE').'" AS text, '
	. ' "" AS section,'
	. ' "1" AS browsernav '
	. ' FROM #__rubberdoc_docs AS a '
	. ' WHERE ('. $where .')'
	. ' AND a.published = 1'
	. ' AND a.access <= '.(int) $user->get( 'aid' )
	. ' ORDER BY '. $order
	;
	
	// echo str_replace('#_', 'jos', $query);
	
	$db->setQuery( $query, 0, $limit );
	$rows = $db->loadObjectList();

	foreach($rows as $key => $row) {
		$rows[$key]->href = JRoute::_('?option=com_rubberdoc&task=download&id='.$row->id, false);
	}

	return $rows;
}