<?php

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the RubberDoc component
 *
 * @static
 * @package		Joomla
 * @subpackage	RubberDoc
 * @since 1.0
 */
class RubberDocViewDoc extends JView
{
	public function display($tpl = null)
	{
		global $mainframe, $option;
		
		$id = JRequest::getInt('id');
		
		if(!$id)
		{
			JError::raiseError(404, 'Page Not Found');
			return;	
		}
			
		$model =& $this->getModel('doc');
		$model->hit();
		
		$data		=& $model->getData();
		$fileName	=& $data->get('file');
		$dirname	= $mainframe->getParams('com_rubberdoc')->get('rubberdoc_dir', 'rubberdoc');
		$filePath	= JPath::clean( JPATH_SITE.DS.$dirname.DS.$fileName );
		
		if( !JFile::exists( $filePath ) )
		{
			JError::raiseError(404, 'Page Not Found');
			return;
		}
		
		$fileName = $data->get('file');
		$extension = array_pop( explode('.', $fileName) );
		$fileName = $data->get('alias').'.'.$extension;
		$fileContent  = JFile::read( $filePath );
		$fileSize 	  = strlen($fileContent);
		require(JPATH_COMPONENT.DS.'helpers'.DS.'mime.mapping.php');
		$mime		  = $mime_extension_map[$extension]; //application/octet-stream
		
		// required for IE, otherwise Content-disposition is ignored
		if(ini_get('zlib.output_compression'))  {
			ini_set('zlib.output_compression', 'Off');
		}
		
		header("Content-Type: ".$mime);		
        header("Content-Disposition: attachment; filename=\"" . $fileName . "\"; modification-date=\"".$data->get('modified')."\"");
		header("Content-Length: "  . $fileSize);
		
		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");        
        header("Content-Transfer-Encoding: binary");



        if( ! ini_get('safe_mode') ) { // set_time_limit doesn't work in safe mode
		    @set_time_limit(0);
        }
		
		echo $fileContent;
	}
}